package com.freq.mic;

import anywheresoftware.b4a.B4AMenuItem;
import android.app.Activity;
import android.os.Bundle;
import anywheresoftware.b4a.BA;
import anywheresoftware.b4a.BALayout;
import anywheresoftware.b4a.B4AActivity;
import anywheresoftware.b4a.ObjectWrapper;
import anywheresoftware.b4a.objects.ActivityWrapper;
import java.lang.reflect.InvocationTargetException;
import anywheresoftware.b4a.B4AUncaughtException;
import anywheresoftware.b4a.debug.*;
import java.lang.ref.WeakReference;

public class main extends Activity implements B4AActivity{
	public static main mostCurrent;
	static boolean afterFirstLayout;
	static boolean isFirst = true;
    private static boolean processGlobalsRun = false;
	BALayout layout;
	public static BA processBA;
	BA activityBA;
    ActivityWrapper _activity;
    java.util.ArrayList<B4AMenuItem> menuItems;
	public static final boolean fullScreen = false;
	public static final boolean includeTitle = true;
    public static WeakReference<Activity> previousOne;

	@Override
	public void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		if (isFirst) {
			processBA = new BA(this.getApplicationContext(), null, null, "com.freq.mic", "com.freq.mic.main");
			processBA.loadHtSubs(this.getClass());
	        float deviceScale = getApplicationContext().getResources().getDisplayMetrics().density;
	        BALayout.setDeviceScale(deviceScale);
            
		}
		else if (previousOne != null) {
			Activity p = previousOne.get();
			if (p != null && p != this) {
                BA.LogInfo("Killing previous instance (main).");
				p.finish();
			}
		}
		if (!includeTitle) {
        	this.getWindow().requestFeature(android.view.Window.FEATURE_NO_TITLE);
        }
        if (fullScreen) {
        	getWindow().setFlags(android.view.WindowManager.LayoutParams.FLAG_FULLSCREEN,   
        			android.view.WindowManager.LayoutParams.FLAG_FULLSCREEN);
        }
		mostCurrent = this;
        processBA.sharedProcessBA.activityBA = null;
		layout = new BALayout(this);
		setContentView(layout);
		afterFirstLayout = false;
		BA.handler.postDelayed(new WaitForLayout(), 5);

	}
	private static class WaitForLayout implements Runnable {
		public void run() {
			if (afterFirstLayout)
				return;
			if (mostCurrent == null)
				return;
            
			if (mostCurrent.layout.getWidth() == 0) {
				BA.handler.postDelayed(this, 5);
				return;
			}
			mostCurrent.layout.getLayoutParams().height = mostCurrent.layout.getHeight();
			mostCurrent.layout.getLayoutParams().width = mostCurrent.layout.getWidth();
			afterFirstLayout = true;
			mostCurrent.afterFirstLayout();
		}
	}
	private void afterFirstLayout() {
        if (this != mostCurrent)
			return;
		activityBA = new BA(this, layout, processBA, "com.freq.mic", "com.freq.mic.main");
        
        processBA.sharedProcessBA.activityBA = new java.lang.ref.WeakReference<BA>(activityBA);
        anywheresoftware.b4a.objects.ViewWrapper.lastId = 0;
        _activity = new ActivityWrapper(activityBA, "activity");
        anywheresoftware.b4a.Msgbox.isDismissing = false;
        if (BA.isShellModeRuntimeCheck(processBA)) {
			if (isFirst)
				processBA.raiseEvent2(null, true, "SHELL", false);
			processBA.raiseEvent2(null, true, "CREATE", true, "com.freq.mic.main", processBA, activityBA, _activity, anywheresoftware.b4a.keywords.Common.Density);
			_activity.reinitializeForShell(activityBA, "activity");
		}
        initializeProcessGlobals();		
        initializeGlobals();
        
        BA.LogInfo("** Activity (main) Create, isFirst = " + isFirst + " **");
        processBA.raiseEvent2(null, true, "activity_create", false, isFirst);
		isFirst = false;
		if (this != mostCurrent)
			return;
        processBA.setActivityPaused(false);
        BA.LogInfo("** Activity (main) Resume **");
        processBA.raiseEvent(null, "activity_resume");
        if (android.os.Build.VERSION.SDK_INT >= 11) {
			try {
				android.app.Activity.class.getMethod("invalidateOptionsMenu").invoke(this,(Object[]) null);
			} catch (Exception e) {
				e.printStackTrace();
			}
		}

	}
	public void addMenuItem(B4AMenuItem item) {
		if (menuItems == null)
			menuItems = new java.util.ArrayList<B4AMenuItem>();
		menuItems.add(item);
	}
	@Override
	public boolean onCreateOptionsMenu(android.view.Menu menu) {
		super.onCreateOptionsMenu(menu);
		if (menuItems == null)
			return false;
		for (B4AMenuItem bmi : menuItems) {
			android.view.MenuItem mi = menu.add(bmi.title);
			if (bmi.drawable != null)
				mi.setIcon(bmi.drawable);
            if (android.os.Build.VERSION.SDK_INT >= 11) {
				try {
                    if (bmi.addToBar) {
				        android.view.MenuItem.class.getMethod("setShowAsAction", int.class).invoke(mi, 1);
                    }
				} catch (Exception e) {
					e.printStackTrace();
				}
			}
			mi.setOnMenuItemClickListener(new B4AMenuItemsClickListener(bmi.eventName.toLowerCase(BA.cul)));
		}
		return true;
	}
    public void onWindowFocusChanged(boolean hasFocus) {
       super.onWindowFocusChanged(hasFocus);
       if (processBA.subExists("activity_windowfocuschanged"))
           processBA.raiseEvent2(null, true, "activity_windowfocuschanged", false, hasFocus);
    }
	private class B4AMenuItemsClickListener implements android.view.MenuItem.OnMenuItemClickListener {
		private final String eventName;
		public B4AMenuItemsClickListener(String eventName) {
			this.eventName = eventName;
		}
		public boolean onMenuItemClick(android.view.MenuItem item) {
			processBA.raiseEvent(item.getTitle(), eventName + "_click");
			return true;
		}
	}
    public static Class<?> getObject() {
		return main.class;
	}
    private Boolean onKeySubExist = null;
    private Boolean onKeyUpSubExist = null;
	@Override
	public boolean onKeyDown(int keyCode, android.view.KeyEvent event) {
		if (onKeySubExist == null)
			onKeySubExist = processBA.subExists("activity_keypress");
		if (onKeySubExist) {
			if (keyCode == anywheresoftware.b4a.keywords.constants.KeyCodes.KEYCODE_BACK &&
					android.os.Build.VERSION.SDK_INT >= 18) {
				HandleKeyDelayed hk = new HandleKeyDelayed();
				hk.kc = keyCode;
				BA.handler.post(hk);
				return true;
			}
			else {
				boolean res = new HandleKeyDelayed().runDirectly(keyCode);
				if (res)
					return true;
			}
		}
		return super.onKeyDown(keyCode, event);
	}
	private class HandleKeyDelayed implements Runnable {
		int kc;
		public void run() {
			runDirectly(kc);
		}
		public boolean runDirectly(int keyCode) {
			Boolean res =  (Boolean)processBA.raiseEvent2(_activity, false, "activity_keypress", false, keyCode);
			if (res == null || res == true) {
                return true;
            }
            else if (keyCode == anywheresoftware.b4a.keywords.constants.KeyCodes.KEYCODE_BACK) {
				finish();
				return true;
			}
            return false;
		}
		
	}
    @Override
	public boolean onKeyUp(int keyCode, android.view.KeyEvent event) {
		if (onKeyUpSubExist == null)
			onKeyUpSubExist = processBA.subExists("activity_keyup");
		if (onKeyUpSubExist) {
			Boolean res =  (Boolean)processBA.raiseEvent2(_activity, false, "activity_keyup", false, keyCode);
			if (res == null || res == true)
				return true;
		}
		return super.onKeyUp(keyCode, event);
	}
	@Override
	public void onNewIntent(android.content.Intent intent) {
		this.setIntent(intent);
	}
    @Override 
	public void onPause() {
		super.onPause();
        if (_activity == null) //workaround for emulator bug (Issue 2423)
            return;
		anywheresoftware.b4a.Msgbox.dismiss(true);
        BA.LogInfo("** Activity (main) Pause, UserClosed = " + activityBA.activity.isFinishing() + " **");
        processBA.raiseEvent2(_activity, true, "activity_pause", false, activityBA.activity.isFinishing());		
        processBA.setActivityPaused(true);
        mostCurrent = null;
        if (!activityBA.activity.isFinishing())
			previousOne = new WeakReference<Activity>(this);
        anywheresoftware.b4a.Msgbox.isDismissing = false;
	}

	@Override
	public void onDestroy() {
        super.onDestroy();
		previousOne = null;
	}
    @Override 
	public void onResume() {
		super.onResume();
        mostCurrent = this;
        anywheresoftware.b4a.Msgbox.isDismissing = false;
        if (activityBA != null) { //will be null during activity create (which waits for AfterLayout).
        	ResumeMessage rm = new ResumeMessage(mostCurrent);
        	BA.handler.post(rm);
        }
	}
    private static class ResumeMessage implements Runnable {
    	private final WeakReference<Activity> activity;
    	public ResumeMessage(Activity activity) {
    		this.activity = new WeakReference<Activity>(activity);
    	}
		public void run() {
			if (mostCurrent == null || mostCurrent != activity.get())
				return;
			processBA.setActivityPaused(false);
            BA.LogInfo("** Activity (main) Resume **");
		    processBA.raiseEvent(mostCurrent._activity, "activity_resume", (Object[])null);
		}
    }
	@Override
	protected void onActivityResult(int requestCode, int resultCode,
	      android.content.Intent data) {
		processBA.onActivityResult(requestCode, resultCode, data);
	}
	private static void initializeGlobals() {
		processBA.raiseEvent2(null, true, "globals", false, (Object[])null);
	}

public anywheresoftware.b4a.keywords.Common __c = null;
public static anywheresoftware.b4a.objects.MediaPlayerWrapper _mp = null;
public static int _buffersize = 0;
public static int _samplerate = 0;
public static int _channelconfig = 0;
public static int _audioformat = 0;
public static int _audiosource = 0;
public static int _nochnls = 0;
public static int _bitspersample = 0;
public static int _datasize = 0;
public stevel05.audiorecord.AudioRecording _ar = null;
public anywheresoftware.b4a.agraham.threading.Threading _record = null;
public static long _starttime = 0L;
public anywheresoftware.b4a.objects.LabelWrapper _dblbl = null;
public anywheresoftware.b4a.objects.LabelWrapper _fslbl = null;
public anywheresoftware.b4a.objects.ButtonWrapper _button1 = null;
  public Object[] GetGlobals() {
		return new Object[] {"Activity",mostCurrent._activity,"AR",mostCurrent._ar,"AudioFormat",_audioformat,"AudioSource",_audiosource,"BitsPerSample",_bitspersample,"BufferSize",_buffersize,"Button1",mostCurrent._button1,"ChannelConfig",_channelconfig,"DataSize",_datasize,"DbLbl",mostCurrent._dblbl,"FsLbl",mostCurrent._fslbl,"MP",_mp,"NoChnls",_nochnls,"Record",mostCurrent._record,"SampleRate",_samplerate,"StartTime",_starttime};
}

public static boolean isAnyActivityVisible() {
    boolean vis = false;
vis = vis | (main.mostCurrent != null);
return vis;}

public static void killProgram() {
     {
            Activity __a = null;
            if (main.previousOne != null) {
				__a = main.previousOne.get();
			}
            else {
                BA ba = main.mostCurrent.processBA.sharedProcessBA.activityBA.get();
                if (ba != null) __a = ba.activity;
            }
            if (__a != null)
				__a.finish();}

}
public static String  _activity_create(boolean _firsttime) throws Exception{
		Debug.PushSubsStack("Activity_Create (main) ","main",0,mostCurrent.activityBA,mostCurrent);
try {
Debug.locals.put("FirstTime", _firsttime);
 BA.debugLineNum = 37;BA.debugLine="Sub Activity_Create(FirstTime As Boolean)";
Debug.ShouldStop(16);
 BA.debugLineNum = 39;BA.debugLine="Activity.LoadLayout(\"1\")";
Debug.ShouldStop(64);
mostCurrent._activity.LoadLayout("1",mostCurrent.activityBA);
 BA.debugLineNum = 41;BA.debugLine="MP.Initialize";
Debug.ShouldStop(256);
_mp.Initialize();
 BA.debugLineNum = 43;BA.debugLine="Record.Initialise(\"Rec\")";
Debug.ShouldStop(1024);
mostCurrent._record.Initialise(processBA,"Rec");
 BA.debugLineNum = 45;BA.debugLine="AudioSource   	= AR.A_Src_Mic";
Debug.ShouldStop(4096);
_audiosource = mostCurrent._ar.A_SRC_MIC;
 BA.debugLineNum = 46;BA.debugLine="SampleRate    	= 44100";
Debug.ShouldStop(8192);
_samplerate = (int) (44100);
 BA.debugLineNum = 47;BA.debugLine="ChannelConfig	= AR.Ch_Conf_Mono";
Debug.ShouldStop(16384);
_channelconfig = mostCurrent._ar.CH_CONF_MONO;
 BA.debugLineNum = 48;BA.debugLine="NoChnls			= 1";
Debug.ShouldStop(32768);
_nochnls = (int) (1);
 BA.debugLineNum = 49;BA.debugLine="AudioFormat		= AR.Af_PCM_16";
Debug.ShouldStop(65536);
_audioformat = mostCurrent._ar.AF_PCM_16;
 BA.debugLineNum = 50;BA.debugLine="BitsPerSample	= 16";
Debug.ShouldStop(131072);
_bitspersample = (int) (16);
 BA.debugLineNum = 53;BA.debugLine="BufferSize = AR.GetMinBufferSize(SampleRate, ChannelConfig, AudioFormat)";
Debug.ShouldStop(1048576);
_buffersize = mostCurrent._ar.GetMinBufferSize(_samplerate,_channelconfig,_audioformat);
 BA.debugLineNum = 55;BA.debugLine="If BufferSize < 0 Then";
Debug.ShouldStop(4194304);
if (_buffersize<0) { 
 BA.debugLineNum = 56;BA.debugLine="Msgbox(\"Error de Buffer, el Hardware no suporta los parametros de grabacion\",\"Error de Buffer\")";
Debug.ShouldStop(8388608);
anywheresoftware.b4a.keywords.Common.Msgbox("Error de Buffer, el Hardware no suporta los parametros de grabacion","Error de Buffer",mostCurrent.activityBA);
 BA.debugLineNum = 57;BA.debugLine="Activity.Finish";
Debug.ShouldStop(16777216);
mostCurrent._activity.Finish();
 };
 BA.debugLineNum = 60;BA.debugLine="AR.Initialize(AudioSource,SampleRate,ChannelConfig,AudioFormat,BufferSize)";
Debug.ShouldStop(134217728);
mostCurrent._ar.Initialize(processBA,_audiosource,_samplerate,_channelconfig,_audioformat,_buffersize);
 BA.debugLineNum = 62;BA.debugLine="AR.StartRecording";
Debug.ShouldStop(536870912);
mostCurrent._ar.StartRecording();
 BA.debugLineNum = 64;BA.debugLine="StartTime = DateTime.Now";
Debug.ShouldStop(-2147483648);
_starttime = anywheresoftware.b4a.keywords.Common.DateTime.getNow();
 BA.debugLineNum = 66;BA.debugLine="End Sub";
Debug.ShouldStop(2);
return "";
}
catch (Exception e) {
			Debug.ErrorCaught(e);
			throw e;
		} 
finally {
			Debug.PopSubsStack();
		}}
public static boolean  _activity_keypress(int _keycode) throws Exception{
		Debug.PushSubsStack("Activity_KeyPress (main) ","main",0,mostCurrent.activityBA,mostCurrent);
try {
Debug.locals.put("KeyCode", _keycode);
 BA.debugLineNum = 135;BA.debugLine="Sub Activity_KeyPress (KeyCode As Int) As Boolean";
Debug.ShouldStop(64);
 BA.debugLineNum = 137;BA.debugLine="If KeyCode = KeyCodes.KEYCODE_BACK Then";
Debug.ShouldStop(256);
if (_keycode==anywheresoftware.b4a.keywords.Common.KeyCodes.KEYCODE_BACK) { 
 BA.debugLineNum = 138;BA.debugLine="If Record.Running Then";
Debug.ShouldStop(512);
if (mostCurrent._record.getRunning()) { 
 BA.debugLineNum = 139;BA.debugLine="Record.Interrupt";
Debug.ShouldStop(1024);
mostCurrent._record.Interrupt();
 BA.debugLineNum = 140;BA.debugLine="ToastMessageShow(\"Stopping ..., press back again to exit\",False)";
Debug.ShouldStop(2048);
anywheresoftware.b4a.keywords.Common.ToastMessageShow("Stopping ..., press back again to exit",anywheresoftware.b4a.keywords.Common.False);
 BA.debugLineNum = 141;BA.debugLine="Return True";
Debug.ShouldStop(4096);
if (true) return anywheresoftware.b4a.keywords.Common.True;
 };
 };
 BA.debugLineNum = 145;BA.debugLine="End Sub";
Debug.ShouldStop(65536);
return false;
}
catch (Exception e) {
			Debug.ErrorCaught(e);
			throw e;
		} 
finally {
			Debug.PopSubsStack();
		}}
public static String  _activity_pause(boolean _userclosed) throws Exception{
		Debug.PushSubsStack("Activity_Pause (main) ","main",0,mostCurrent.activityBA,mostCurrent);
try {
Debug.locals.put("UserClosed", _userclosed);
 BA.debugLineNum = 130;BA.debugLine="Sub Activity_Pause (UserClosed As Boolean)";
Debug.ShouldStop(2);
 BA.debugLineNum = 131;BA.debugLine="AR.release";
Debug.ShouldStop(4);
mostCurrent._ar.release();
 BA.debugLineNum = 132;BA.debugLine="If Record.Running Then Record.Interrupt";
Debug.ShouldStop(8);
if (mostCurrent._record.getRunning()) { 
mostCurrent._record.Interrupt();};
 BA.debugLineNum = 133;BA.debugLine="End Sub";
Debug.ShouldStop(16);
return "";
}
catch (Exception e) {
			Debug.ErrorCaught(e);
			throw e;
		} 
finally {
			Debug.PopSubsStack();
		}}
public static String  _activity_resume() throws Exception{
		Debug.PushSubsStack("Activity_Resume (main) ","main",0,mostCurrent.activityBA,mostCurrent);
try {
 BA.debugLineNum = 126;BA.debugLine="Sub Activity_Resume";
Debug.ShouldStop(536870912);
 BA.debugLineNum = 128;BA.debugLine="End Sub";
Debug.ShouldStop(-2147483648);
return "";
}
catch (Exception e) {
			Debug.ErrorCaught(e);
			throw e;
		} 
finally {
			Debug.PopSubsStack();
		}}
public static String  _audiorecord_markerreached() throws Exception{
		Debug.PushSubsStack("AudioRecord_MarkerReached (main) ","main",0,mostCurrent.activityBA,mostCurrent);
try {
 BA.debugLineNum = 122;BA.debugLine="Sub AudioRecord_MarkerReached";
Debug.ShouldStop(33554432);
 BA.debugLineNum = 123;BA.debugLine="Log(\"MRCalled\")";
Debug.ShouldStop(67108864);
anywheresoftware.b4a.keywords.Common.Log("MRCalled");
 BA.debugLineNum = 124;BA.debugLine="End Sub";
Debug.ShouldStop(134217728);
return "";
}
catch (Exception e) {
			Debug.ErrorCaught(e);
			throw e;
		} 
finally {
			Debug.PopSubsStack();
		}}
public static String  _audiorecord_periodpassed() throws Exception{
		Debug.PushSubsStack("AudioRecord_PeriodPassed (main) ","main",0,mostCurrent.activityBA,mostCurrent);
try {
 BA.debugLineNum = 118;BA.debugLine="Sub AudioRecord_PeriodPassed";
Debug.ShouldStop(2097152);
 BA.debugLineNum = 119;BA.debugLine="Log(\"PPCalled\")";
Debug.ShouldStop(4194304);
anywheresoftware.b4a.keywords.Common.Log("PPCalled");
 BA.debugLineNum = 120;BA.debugLine="End Sub";
Debug.ShouldStop(8388608);
return "";
}
catch (Exception e) {
			Debug.ErrorCaught(e);
			throw e;
		} 
finally {
			Debug.PopSubsStack();
		}}
public static String  _button1_click() throws Exception{
		Debug.PushSubsStack("Button1_Click (main) ","main",0,mostCurrent.activityBA,mostCurrent);
try {
 BA.debugLineNum = 154;BA.debugLine="Sub Button1_Click";
Debug.ShouldStop(33554432);
 BA.debugLineNum = 155;BA.debugLine="StartTime = DateTime.Now";
Debug.ShouldStop(67108864);
_starttime = anywheresoftware.b4a.keywords.Common.DateTime.getNow();
 BA.debugLineNum = 156;BA.debugLine="FreqDetect";
Debug.ShouldStop(134217728);
_freqdetect();
 BA.debugLineNum = 157;BA.debugLine="End Sub";
Debug.ShouldStop(268435456);
return "";
}
catch (Exception e) {
			Debug.ErrorCaught(e);
			throw e;
		} 
finally {
			Debug.PopSubsStack();
		}}
public static String  _freqdetect() throws Exception{
		Debug.PushSubsStack("FreqDetect (main) ","main",0,mostCurrent.activityBA,mostCurrent);
try {
int _n = 0;
byte[] _sound = null;
double[] _soundd = null;
int _sum = 0;
int _cont = 0;
anywheresoftware.b4a.agraham.fft.FFT _fft = null;
double[] _fftreal = null;
double[] _fftimg = null;
double[] _fftamp = null;
int _peak = 0;
 BA.debugLineNum = 69;BA.debugLine="Sub FreqDetect";
Debug.ShouldStop(16);
 BA.debugLineNum = 74;BA.debugLine="Dim N As Int";
Debug.ShouldStop(512);
_n = 0;Debug.locals.put("N", _n);
 BA.debugLineNum = 75;BA.debugLine="N = 16384";
Debug.ShouldStop(1024);
_n = (int) (16384);Debug.locals.put("N", _n);
 BA.debugLineNum = 77;BA.debugLine="Dim sound(N) As Byte";
Debug.ShouldStop(4096);
_sound = new byte[_n];
;Debug.locals.put("sound", _sound);
 BA.debugLineNum = 78;BA.debugLine="Dim soundD(N) As Double";
Debug.ShouldStop(8192);
_soundd = new double[_n];
;Debug.locals.put("soundD", _soundd);
 BA.debugLineNum = 80;BA.debugLine="DataSize=0";
Debug.ShouldStop(32768);
_datasize = (int) (0);
 BA.debugLineNum = 81;BA.debugLine="Log(\"Sampling...\")";
Debug.ShouldStop(65536);
anywheresoftware.b4a.keywords.Common.Log("Sampling...");
 BA.debugLineNum = 82;BA.debugLine="Do While True";
Debug.ShouldStop(131072);
while (anywheresoftware.b4a.keywords.Common.True) {
 BA.debugLineNum = 83;BA.debugLine="Dim Sum As Int";
Debug.ShouldStop(262144);
_sum = 0;Debug.locals.put("Sum", _sum);
 BA.debugLineNum = 84;BA.debugLine="sound = AR.ReadBytes(0,BufferSize)";
Debug.ShouldStop(524288);
_sound = mostCurrent._ar.ReadBytes((int) (0),_buffersize);Debug.locals.put("sound", _sound);
 BA.debugLineNum = 85;BA.debugLine="DataSize = DataSize + sound.Length";
Debug.ShouldStop(1048576);
_datasize = (int) (_datasize+_sound.length);
 BA.debugLineNum = 87;BA.debugLine="If Record.IsInterrupted Then Exit";
Debug.ShouldStop(4194304);
if (mostCurrent._record.getIsInterrupted()) { 
if (true) break;};
 BA.debugLineNum = 89;BA.debugLine="If DateTime.Now > StartTime + \"4000\" Then Exit";
Debug.ShouldStop(16777216);
if (anywheresoftware.b4a.keywords.Common.DateTime.getNow()>_starttime+(double)(Double.parseDouble("4000"))) { 
if (true) break;};
 }
;
 BA.debugLineNum = 92;BA.debugLine="For cont = 0 To sound.Length -1";
Debug.ShouldStop(134217728);
{
final int step49 = 1;
final int limit49 = (int) (_sound.length-1);
for (_cont = (int) (0); (step49 > 0 && _cont <= limit49) || (step49 < 0 && _cont >= limit49); _cont = ((int)(0 + _cont + step49))) {
Debug.locals.put("cont", _cont);
 BA.debugLineNum = 93;BA.debugLine="soundD(cont) = sound(cont)";
Debug.ShouldStop(268435456);
_soundd[_cont] = _sound[_cont];Debug.locals.put("soundD", _soundd);
 }
}Debug.locals.put("cont", _cont);
;
 BA.debugLineNum = 96;BA.debugLine="Dim FFT As FFT";
Debug.ShouldStop(-2147483648);
_fft = new anywheresoftware.b4a.agraham.fft.FFT();Debug.locals.put("FFT", _fft);
 BA.debugLineNum = 97;BA.debugLine="Dim FFTReal(N/2) As Double";
Debug.ShouldStop(1);
_fftreal = new double[(int) (_n/(double)2)];
;Debug.locals.put("FFTReal", _fftreal);
 BA.debugLineNum = 98;BA.debugLine="Dim FFTImg(N/2) As Double";
Debug.ShouldStop(2);
_fftimg = new double[(int) (_n/(double)2)];
;Debug.locals.put("FFTImg", _fftimg);
 BA.debugLineNum = 99;BA.debugLine="Dim FFTAmp(N/2) As Double";
Debug.ShouldStop(4);
_fftamp = new double[(int) (_n/(double)2)];
;Debug.locals.put("FFTAmp", _fftamp);
 BA.debugLineNum = 100;BA.debugLine="FFT.Transform2(soundD, FFTReal, FFTImg)";
Debug.ShouldStop(8);
_fft.Transform2(_soundd,_fftreal,_fftimg);
 BA.debugLineNum = 101;BA.debugLine="FFTAmp = FFT.ToAmplitude(FFTReal,FFTImg)";
Debug.ShouldStop(16);
_fftamp = _fft.ToAmplitude(_fftreal,_fftimg);Debug.locals.put("FFTAmp", _fftamp);
 BA.debugLineNum = 104;BA.debugLine="Dim Peak As Int = 0";
Debug.ShouldStop(128);
_peak = (int) (0);Debug.locals.put("Peak", _peak);Debug.locals.put("Peak", _peak);
 BA.debugLineNum = 106;BA.debugLine="For cont = 0 To N/2 -1";
Debug.ShouldStop(512);
{
final int step59 = 1;
final int limit59 = (int) (_n/(double)2-1);
for (_cont = (int) (0); (step59 > 0 && _cont <= limit59) || (step59 < 0 && _cont >= limit59); _cont = ((int)(0 + _cont + step59))) {
Debug.locals.put("cont", _cont);
 BA.debugLineNum = 108;BA.debugLine="If (FFTAmp(cont) > FFTAmp(Peak)) Then";
Debug.ShouldStop(2048);
if ((_fftamp[_cont]>_fftamp[_peak])) { 
 BA.debugLineNum = 109;BA.debugLine="Peak = cont";
Debug.ShouldStop(4096);
_peak = _cont;Debug.locals.put("Peak", _peak);
 };
 BA.debugLineNum = 112;BA.debugLine="Log(SampleRate / N * Peak * 2) 'Frecuency.";
Debug.ShouldStop(32768);
anywheresoftware.b4a.keywords.Common.Log(BA.NumberToString(_samplerate/(double)_n*_peak*2));
 }
}Debug.locals.put("cont", _cont);
;
 BA.debugLineNum = 116;BA.debugLine="End Sub";
Debug.ShouldStop(524288);
return "";
}
catch (Exception e) {
			Debug.ErrorCaught(e);
			throw e;
		} 
finally {
			Debug.PopSubsStack();
		}}

public static void initializeProcessGlobals() {
    if (mostCurrent != null && mostCurrent.activityBA != null) {
Debug.StartDebugging(mostCurrent.activityBA, 20900, new int[] {5}, "e5372a1f-4fca-43f1-919d-bc5702337232");}

    if (main.processGlobalsRun == false) {
	    main.processGlobalsRun = true;
		try {
		        main._process_globals();
		
        } catch (Exception e) {
			throw new RuntimeException(e);
		}
    }
}public static String  _globals() throws Exception{
 //BA.debugLineNum = 18;BA.debugLine="Sub Globals";
 //BA.debugLineNum = 20;BA.debugLine="Dim BufferSize As Int";
_buffersize = 0;
 //BA.debugLineNum = 21;BA.debugLine="Dim SampleRate As Int";
_samplerate = 0;
 //BA.debugLineNum = 22;BA.debugLine="Dim ChannelConfig As Int";
_channelconfig = 0;
 //BA.debugLineNum = 23;BA.debugLine="Dim AudioFormat As Int";
_audioformat = 0;
 //BA.debugLineNum = 24;BA.debugLine="Dim AudioSource As Int";
_audiosource = 0;
 //BA.debugLineNum = 25;BA.debugLine="Dim NoChnls,BitsPerSample,DataSize As Int";
_nochnls = 0;
_bitspersample = 0;
_datasize = 0;
 //BA.debugLineNum = 27;BA.debugLine="Dim AR As AudioRecord";
mostCurrent._ar = new stevel05.audiorecord.AudioRecording();
 //BA.debugLineNum = 28;BA.debugLine="Dim Record As Thread";
mostCurrent._record = new anywheresoftware.b4a.agraham.threading.Threading();
 //BA.debugLineNum = 30;BA.debugLine="Dim StartTime As Long";
_starttime = 0L;
 //BA.debugLineNum = 32;BA.debugLine="Dim DbLbl, FsLbl As Label";
mostCurrent._dblbl = new anywheresoftware.b4a.objects.LabelWrapper();
mostCurrent._fslbl = new anywheresoftware.b4a.objects.LabelWrapper();
 //BA.debugLineNum = 33;BA.debugLine="Private Button1 As Button";
mostCurrent._button1 = new anywheresoftware.b4a.objects.ButtonWrapper();
 //BA.debugLineNum = 35;BA.debugLine="End Sub";
return "";
}
public static String  _process_globals() throws Exception{
 //BA.debugLineNum = 12;BA.debugLine="Sub Process_Globals";
 //BA.debugLineNum = 14;BA.debugLine="Dim MP As MediaPlayer";
_mp = new anywheresoftware.b4a.objects.MediaPlayerWrapper();
 //BA.debugLineNum = 16;BA.debugLine="End Sub";
return "";
}
public static String  _rec_ended(boolean _endedok,String _error) throws Exception{
		Debug.PushSubsStack("Rec_Ended (main) ","main",0,mostCurrent.activityBA,mostCurrent);
try {
Debug.locals.put("endedOK", _endedok);
Debug.locals.put("Error", _error);
 BA.debugLineNum = 147;BA.debugLine="Sub Rec_Ended(endedOK As Boolean, Error As String)";
Debug.ShouldStop(262144);
 BA.debugLineNum = 149;BA.debugLine="AR.Stop";
Debug.ShouldStop(1048576);
mostCurrent._ar.Stop();
 BA.debugLineNum = 150;BA.debugLine="AR.release";
Debug.ShouldStop(2097152);
mostCurrent._ar.release();
 BA.debugLineNum = 152;BA.debugLine="End Sub";
Debug.ShouldStop(8388608);
return "";
}
catch (Exception e) {
			Debug.ErrorCaught(e);
			throw e;
		} 
finally {
			Debug.PopSubsStack();
		}}
}
